'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _shallowEqual = require('shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright (c) 2016, David Bordoley
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * https://raw.githubusercontent.com/bordoley/ReactiveDataflow/master/LICENSE file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

// These are the same type definitions used by RxES7

var ReactiveDataflowComponentImpl = function (_React$Component) {
  _inherits(ReactiveDataflowComponentImpl, _React$Component);

  function ReactiveDataflowComponentImpl(props) {
    _classCallCheck(this, ReactiveDataflowComponentImpl);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReactiveDataflowComponentImpl).call(this, props));

    _this.state = { props: null };
    _this.subscription = null;
    return _this;
  }

  _createClass(ReactiveDataflowComponentImpl, [{
    key: '_subscribe',
    value: function _subscribe(props) {
      var _this2 = this;

      var onNext = function onNext(props) {
        return _this2.setState({ props: props });
      };
      var onCompleted = function onCompleted() {};
      var onError = function onError() {};

      this.subscription = props.source.subscribe({
        onNext: onNext,
        onError: onError,
        onCompleted: onCompleted
      });
    }
  }, {
    key: '_disposeSubscription',
    value: function _disposeSubscription() {
      var subscription = this.subscription;
      if (subscription != null) {
        subscription.dispose();
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this._subscribe(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(next) {
      this._disposeSubscription();
      this._subscribe(next);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._disposeSubscription();
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _shallowEqual2.default)(this.state.props, nextState.props);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.state.props;
      var render = this.props.render;

      return props != null ? render(props) : null;
    }
  }]);

  return ReactiveDataflowComponentImpl;
}(React.Component);

// FIXME: export this directly when flow 0.23 ships


var ReactiveDataflowComponent = function ReactiveDataflowComponent(props) {
  return React.createElement(ReactiveDataflowComponentImpl, props);
};

exports.default = ReactiveDataflowComponent;